<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Src/NLME/Auxiliary/initializePopParams.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_413f4e031a85da0d68269c6fd2f76e1c.html">Src</a></li><li class="navelem"><a class="el" href="../../dir_8672bca13fc16af0e54d5ddc01090308.html">NLME</a></li><li class="navelem"><a class="el" href="../../dir_d544197a650feee977d1b0e201b59710.html">Auxiliary</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">initializePopParams.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d1/dbd/initialize_pop_params_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;%%%------------------------------------------------------------------------</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;%and uses the <span class="keywordflow">default</span> fnHandle <span class="keywordflow">for</span> optimization.</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;function [ beta0, D0,  parameters0]=<a class="code" href="../../d1/dbd/initialize_pop_params_8m.html#ab10ea8860d9c38fbaf84e63dd8eb0bb8">initializePopParams</a>(SSoptions,singlecell_estimates)</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;% EM</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keywordflow">if</span> strcmp(SSoptions.Optimization,<span class="stringliteral">&#39;LGTS_EM&#39;</span>)</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;%     <span class="keywordflow">if</span> ~isempty(SSoptions.covariate_term)</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;%         beta0=SSoptions.initialbeta0;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;%         % TO DO: add error flag</div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="../../d1/dbd/initialize_pop_params_8m.html#ab10ea8860d9c38fbaf84e63dd8eb0bb8">   15</a></span>&#160;%     <span class="keywordflow">else</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keywordflow">if</span>(isempty(SSoptions.initialbeta0))</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;            disp(<span class="stringliteral">&#39;No initial values for mean estimate given: initialising with mean of single-cell estimates \n&#39;</span>);</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;            beta0= mean(cat(1,singlecell_estimates));</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;            beta0=SSoptions.initialbeta0;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        end</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;%     end</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordflow">if</span> ~isempty(SSoptions.initialD0)</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        D0=SSoptions.initialD0;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    else</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        disp(&#39;No initial values for covariance estimate given: initialising with covariance of single-cell estimates \n&#39;);</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        D0= cov(singlecell_estimates);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    end</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    parameters0=[];</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;% Optimization</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;elseif strcmp(SSoptions.Optimization,&#39;Optimizer&#39;)</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        if(isempty(SSoptions.initialbeta0))</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            disp(&#39;No initial values for mean estimate given: initialising with mean of single-cell estimates \n&#39;);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            beta0= mean(singlecell_estimates);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        else</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            beta0=SSoptions.initialbeta0;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        end</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    if ~isempty(SSoptions.initialD0)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        D0=SSoptions.initialD0;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;      if ~isvector(D0)    % If we had inputed a matrix then vectorise it for the optimization</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                                    % Else use it directly as it is</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        if strcmp(SSoptions.DiagD, &#39;diagonal&#39;)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            disp(&#39;Estimating diagonal matrix D as requested \n&#39;);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            singlecell_estimates_d=diag(D0);   % vector</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;             if SSoptions.optim.tologVar==true</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;             singlecell_estimates_d=log(singlecell_estimates_d);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;             end</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        else</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            var_d=diag(D0)&#39;;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            [~,CorrMat]=cov2corr(D0);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            CorrMat_tril=tril(CorrMat,-1);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            if all(CorrMat_tril==0)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;             if SSoptions.objOpts.tologVar==true</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;             singlecell_estimates_d=log(var_d);</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;             else</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;             singlecell_estimates_d=[var_d];</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;             end</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            else</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;             if SSoptions.objOpts.tologVar==true</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;               var_d=log(var_d);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;             end</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            singlecell_estimates_d=[var_d&#39;,CorrMat_tril(:)&#39;]; % vector</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            end</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        end</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;      else</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;          singlecell_estimates_d=D0;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;      end</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    else</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        disp(&#39;No initial values for covariance estimate given: initialising with covariance of single-cell estimates \n&#39;);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        if strcmp(SSoptions.DiagD, &#39;diagonal&#39;)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            D0= diag(cov(singlecell_estimates));</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            singlecell_estimates_d=diag(D0);         %vector</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        elseif strcmp(SSoptions.DiagD, &#39;full&#39;)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            D0= cov(singlecell_estimates);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            [~,CorrMat]=cov2corr(D0);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            mapID=tril(ones(size(CorrMat)),-1);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            CorrMat_tril=CorrMat(mapID==1);</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            var_d=diag(D0)&#39;;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;             if SSoptions.objOpts.tologVar==true</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;               var_d=log(var_d);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;             end</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            singlecell_estimates_d=[var_d,CorrMat_tril(:)&#39;]; %vector</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        elseif  strcmp(SSoptions.DiagD, &#39;structured&#39;)</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            disp(&#39;todo: implement structured matrix as well&#39;);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        end</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    end</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    parameters0=[beta0,singlecell_estimates_d]; % All parameters aggregated</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;end</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="ainitialize_pop_params_8m_html_ab10ea8860d9c38fbaf84e63dd8eb0bb8"><div class="ttname"><a href="../../d1/dbd/initialize_pop_params_8m.html#ab10ea8860d9c38fbaf84e63dd8eb0bb8">initializePopParams</a></div><div class="ttdeci">function initializePopParams(in SSoptions, in singlecell_estimates)</div><div class="ttdoc">Initialises the mean and covariance parameters of the second stage optimization, either for EM or opt...</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
